dnl aclocal.m4 generated automatically by aclocal 1.4

dnl Copyright (C) 1994, 1995-8, 1999 Free Software Foundation, Inc.
dnl This file is free software; the Free Software Foundation
dnl gives unlimited permission to copy and/or distribute it,
dnl with or without modifications, as long as this notice is preserved.

dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY, to the extent permitted by law; without
dnl even the implied warranty of MERCHANTABILITY or FITNESS FOR A
dnl PARTICULAR PURPOSE.

dnl       Copyright (C) 1998 Claus-Justus Heine
dnl
dnl This program is free software; you can redistribute it and/or modify
dnl it under the terms of the GNU General Public License as published by
dnl the Free Software Foundation; either version 2, or (at your option)
dnl any later version.
dnl
dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl GNU General Public License for more details.
dnl
dnl You should have received a copy of the GNU General Public License
dnl along with this program; see the file COPYING.  If not, write to
dnl the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
dnl
dnl 
dnl $RCSfile: acinclude.m4,v $
dnl $Revision: 1.5 $
dnl $Date: 1999/02/22 12:25:14 $
dnl

dnl     set prefix to its proper value, so that one can define substitutions
dnl     depending on the value of prefix

AC_DEFUN(AC_SET_PREFIX,
[test "x$prefix" = xNONE && prefix=$ac_default_prefix
# Let make expand exec_prefix.
test "x$exec_prefix" = xNONE && exec_prefix='${prefix}'
])

AC_DEFUN(FTTOOLS_DOC_OPTIONS,
[
dnl location to install the html documentation in
AC_ARG_WITH(htmldir,
[  --with-htmldir=DIR      where the html documentation should be installed.
                          [PREFIX/share/texi2www/ftape-tools]],
	htmldir=$withval, htmldir=$datadir/texi2www/$DOCNAME)
AC_SUBST(htmldir)

dnl location to install the sgml documentation in
AC_ARG_WITH(sgmldir,
[  --with-sgmldir=DIR      where the sgml documentation should be installed.
                          [PREFIX/share/ftape-tools/sgml]],
	sgmldir=$withval, sgmldir=$PKGDATADIR/sgml)
AC_SUBST(sgmldir)

dnl papersize
AC_ARG_WITH(papersize,
[  --with-papersize=SIZE   paper size to use, SIZE is either a4 or letter
                          [a4]],
	PAPERSIZE=$withval, PAPERSIZE=a4)
AC_SUBST(PAPERSIZE)

dnl info2html server
AC_ARG_WITH(info2html,
[  --with-info2html=URL    info-to-html url to use for "inforef" macros in
                          TeXinfo source code. [http://localhost/cgi-bin/info2html]],
	infoserver=$withval, infoserver='http://localhost/cgi-bin/info2html')
AC_SUBST(infoserver)

dnl LaTeX with postscript fonts.
AC_ARG_WITH(pslatex,
[  --with-pslatex         use postscript fonts for LaTeX. This
                          requires the pslatex package. Only meaningful
                          for the SGML derived formatted documentation [yes]],
	if test x${withval} = xyes; then
		LATEXPATH='$(top_srcdir/etc)'
	else
		LATEXPATH=""
	fi,
	with_pslatex=yes
	LATEXPATH='$(top_srcdir/etc)')
AC_SUBST(LATEXPATH)

dnl install postscript versions of the manaul
AC_ARG_ENABLE(postscript,
[  --enable-postscript     Create and install a Postscript version of
			  the manual as well. Have a good look at the
			  "--with-papersize" option. [disabled]],
	if test x${enableval} = xyes; then
		PS_DOCS=yes
	else		
		PS_DOCS=no
	fi,
	enable_postscript=no
	PS_DOCS=no)
AC_SUBST(PS_DOCS)
AM_CONDITIONAL(PS_DOCS, test x$PS_DOCS = xyes)

dnl Use sgml derived html docs instead of texi2www
AC_ARG_ENABLE(sgml-docs,
[  --enable-sgml-docs      install sgml derived documentation even when
                          the same format can be derived directly from
                          the TeXinfo source code (PS, HTML) [no]],
	SGML_DOCS=${enableval},SGML_DOCS="no")
AC_SUBST(SGML_DOCS)
AM_CONDITIONAL(SGML_DOCS, test x$SGML_DOCS = xyes)
])

# Define a conditional.

AC_DEFUN(AM_CONDITIONAL,
[AC_SUBST($1_TRUE)
AC_SUBST($1_FALSE)
if $2; then
  $1_TRUE=
  $1_FALSE='#'
else
  $1_TRUE='#'
  $1_FALSE=
fi])

# Do all the work for Automake.  This macro actually does too much --
# some checks are only needed if your package does certain things.
# But this isn't really a big deal.

# serial 1

dnl Usage:
dnl AM_INIT_AUTOMAKE(package,version, [no-define])

AC_DEFUN(AM_INIT_AUTOMAKE,
[AC_REQUIRE([AC_PROG_INSTALL])
PACKAGE=[$1]
AC_SUBST(PACKAGE)
VERSION=[$2]
AC_SUBST(VERSION)
dnl test to see if srcdir already configured
if test "`cd $srcdir && pwd`" != "`pwd`" && test -f $srcdir/config.status; then
  AC_MSG_ERROR([source directory already configured; run "make distclean" there first])
fi
ifelse([$3],,
AC_DEFINE_UNQUOTED(PACKAGE, "$PACKAGE", [Name of package])
AC_DEFINE_UNQUOTED(VERSION, "$VERSION", [Version number of package]))
AC_REQUIRE([AM_SANITY_CHECK])
AC_REQUIRE([AC_ARG_PROGRAM])
dnl FIXME This is truly gross.
missing_dir=`cd $ac_aux_dir && pwd`
AM_MISSING_PROG(ACLOCAL, aclocal, $missing_dir)
AM_MISSING_PROG(AUTOCONF, autoconf, $missing_dir)
AM_MISSING_PROG(AUTOMAKE, automake, $missing_dir)
AM_MISSING_PROG(AUTOHEADER, autoheader, $missing_dir)
AM_MISSING_PROG(MAKEINFO, makeinfo, $missing_dir)
AC_REQUIRE([AC_PROG_MAKE_SET])])

#
# Check to make sure that the build environment is sane.
#

AC_DEFUN(AM_SANITY_CHECK,
[AC_MSG_CHECKING([whether build environment is sane])
# Just in case
sleep 1
echo timestamp > conftestfile
# Do `set' in a subshell so we don't clobber the current shell's
# arguments.  Must try -L first in case configure is actually a
# symlink; some systems play weird games with the mod time of symlinks
# (eg FreeBSD returns the mod time of the symlink's containing
# directory).
if (
   set X `ls -Lt $srcdir/configure conftestfile 2> /dev/null`
   if test "[$]*" = "X"; then
      # -L didn't work.
      set X `ls -t $srcdir/configure conftestfile`
   fi
   if test "[$]*" != "X $srcdir/configure conftestfile" \
      && test "[$]*" != "X conftestfile $srcdir/configure"; then

      # If neither matched, then we have a broken ls.  This can happen
      # if, for instance, CONFIG_SHELL is bash and it inherits a
      # broken ls alias from the environment.  This has actually
      # happened.  Such a system could not be considered "sane".
      AC_MSG_ERROR([ls -t appears to fail.  Make sure there is not a broken
alias in your environment])
   fi

   test "[$]2" = conftestfile
   )
then
   # Ok.
   :
else
   AC_MSG_ERROR([newly created file is older than distributed files!
Check your system clock])
fi
rm -f conftest*
AC_MSG_RESULT(yes)])

dnl AM_MISSING_PROG(NAME, PROGRAM, DIRECTORY)
dnl The program must properly implement --version.
AC_DEFUN(AM_MISSING_PROG,
[AC_MSG_CHECKING(for working $2)
# Run test in a subshell; some versions of sh will print an error if
# an executable is not found, even if stderr is redirected.
# Redirect stdin to placate older versions of autoconf.  Sigh.
if ($2 --version) < /dev/null > /dev/null 2>&1; then
   $1=$2
   AC_MSG_RESULT(found)
else
   $1="$3/missing $2"
   AC_MSG_RESULT(missing)
fi
AC_SUBST($1)])

